//+------------------------------------------------------------------+
//|                                                Phreak System.mq4 |
//|                                                   Amritendu Maji |
//+------------------------------------------------------------------+
#property copyright "Amritendu Maji"
#property link      "None"

extern double Lots=0.1;
extern int Slippage=3;
extern int  MagicNumber = 1525;

extern bool MM = false; //Use Money Management or not
extern double RiskPercent = 1; //% of equity to be used as margin

extern int FastPeriod = 20;
extern int SlowPeriod = 25;
extern int PRICEMODE = PRICE_CLOSE;
extern double SmoothConst = 9;

extern int StopLoss = 0;
extern int TakeProfit1 = 10;
extern int TakeProfit2 = 50;
extern int TakeProfit3 = 100;

extern bool UseTrailingStop = false;
extern int TrailStartPips = 50;
extern int TrailStopPips = 50;

extern int TimeFrame = 0;
extern int MaxTrades = 1;

int Current = 0;

bool runnable=true;
bool init=true;
bool BuySignal;
bool SellSignal;
double DMA1, DMA2, TMA1, TMA2;
int ticket;
string EAName = "MA X-Over";
double iLots;
datetime timeprev=0;

int init()
{
 return(0);
}

int deinit()
{
 return(0);
}

int start()
{

 if (UseTrailingStop) {TrailingAlls(TrailStartPips, TrailStopPips);}

/*
 if(timeprev==Time[0])
  return(0);
 timeprev=Time[0];
*/ 
 
 
 TMA1=iCustom(Symbol(),TimeFrame,"Vidya",SlowPeriod,SmoothConst,0,Current);
 TMA2=iCustom(Symbol(),TimeFrame,"Vidya",SlowPeriod,SmoothConst,0,Current+1);
 DMA1=iCustom(Symbol(),TimeFrame,"DEMA",FastPeriod,PRICEMODE,0,Current);
 DMA2=iCustom(Symbol(),TimeFrame,"DEMA",FastPeriod,PRICEMODE,0,Current+1);


    if(MM==true) 
      iLots = LotSize();
    else
      iLots = Lots;
 
 if((DMA1>TMA1) && (DMA2<TMA2))
 {  
   CloseShorts();
   if (CountLongs()<MaxTrades)
   {
    ticket = OpenPendingOrder(OP_BUY,2*iLots,Ask,Slippage,Bid,StopLoss,TakeProfit1,EAName+"-1st",MagicNumber,0,Lime);
    if(ticket<0){Print("Error: ",GetLastError()); return(0);}
    ticket = OpenPendingOrder(OP_BUY,iLots,Ask,Slippage,Bid,StopLoss,TakeProfit2,EAName+"-2nd",MagicNumber,0,Lime);
    if(ticket<0){Print("Error: ",GetLastError()); return(0);}
    ticket = OpenPendingOrder(OP_BUY,iLots,Ask,Slippage,Bid,StopLoss,TakeProfit3,EAName+"-3rd",MagicNumber,0,Lime);
    if(ticket<0){Print("Error: ",GetLastError()); return(0);}
   }
 }
 
 if((DMA1<TMA1) && (DMA2>TMA2))
 {
  CloseLongs();
  if(CountShorts()<MaxTrades)
  {
   ticket = OpenPendingOrder(OP_SELL,2*iLots,Bid,Slippage,Ask,StopLoss,TakeProfit1,EAName+"-1st",MagicNumber,0,HotPink);
   if(ticket<0){Print("Error: ",GetLastError()); return(0);}
   ticket = OpenPendingOrder(OP_SELL,iLots,Bid,Slippage,Ask,StopLoss,TakeProfit2,EAName+"-2nd",MagicNumber,0,HotPink);
   if(ticket<0){Print("Error: ",GetLastError()); return(0);}
   ticket = OpenPendingOrder(OP_SELL,iLots,Bid,Slippage,Ask,StopLoss,TakeProfit3,EAName+"-3rd",MagicNumber,0,HotPink);
   if(ticket<0){Print("Error: ",GetLastError()); return(0);}
  }
 }
  
 return(0);
}


double StopLong(double price,int stop)
{
 if(stop==0)
  return(0);
 else
  return(price-(stop*Point));
}

double StopShort(double price,int stop)
{
 if(stop==0)
  return(0);
 else
  return(price+(stop*Point));
}

double TakeLong(double price,int take)
{
 if(take==0)
  return(0);
 else
  return(price+(take*Point));
}

double TakeShort(double price,int take)
{
 if(take==0)
  return(0);
 else
  return(price-(take*Point));
}


void TrailingAlls(int start,int stop)
{
 int profit;
 double stoptrade;
 double stopcal;
 
 if(stop==0)
  return;
 
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  if(!OrderSelect(trade,SELECT_BY_POS,MODE_TRADES))
   continue;

  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;

  if(OrderType()==OP_BUY)
  {
   profit=NormalizeDouble((Bid-OrderOpenPrice())/Point,0);
   if(profit<start)
    continue;
   stoptrade=OrderStopLoss();
   stopcal=Bid-(stop*Point);
   if(stoptrade==0||(stoptrade!=0&&stopcal>stoptrade))
    OrderModify(OrderTicket(),OrderOpenPrice(),stopcal,OrderTakeProfit(),0,Blue);
  }//Long
  
  if(OrderType()==OP_SELL)
  {
   profit=NormalizeDouble((OrderOpenPrice()-Ask)/Point,0);
   if(profit<start)
    continue;
   stoptrade=OrderStopLoss();
   stopcal=Ask+(stop*Point);
   if(stoptrade==0||(stoptrade!=0&&stopcal<stoptrade))
    OrderModify(OrderTicket(),OrderOpenPrice(),stopcal,OrderTakeProfit(),0,Red);
  }//Shrt
  
 }//for
}


void CloseLongs()
{
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);

  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;
   
  if(OrderType()==OP_BUY)
   OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Blue);
 }//for
}

void CloseShorts()
{
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);

  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;

  if(OrderType()==OP_SELL)
   OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Red);
 }//for
}

int CountLongs()
{
 int count=0;
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  
  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;
   
  if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)
  if(OrderType()==OP_BUY)
   count++;
 }//for
 return(count);
}

int CountShorts()
{
 int count=0;
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  
  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;
   
  if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)
  if(OrderType()==OP_SELL)
   count++;
 }//for
 return(count);
}

int OpenPendingOrder(int pType,double pLots,double pLevel,int sp, double pr, int sl, int tp,string pComment,int pMagic,datetime pExpiration,color pColor)
{
  int ticket=0;
  int err=0;
  int c = 0;
  int NumberOfTries = 100;
  switch (pType)
  {
      case OP_BUYLIMIT:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_BUYLIMIT,pLots,pLevel,sp,StopLong(pr,sl),TakeLong(pLevel,tp),pComment,pMagic,pExpiration,pColor);
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(1000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         }   
         break;
      case OP_BUYSTOP:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_BUYSTOP,pLots,pLevel,sp,StopLong(pr,sl),TakeLong(pLevel,tp),pComment,pMagic,pExpiration,pColor);
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         } 
         break;
      case OP_BUY:
         for(c = 0 ; c < NumberOfTries ; c++)
         {  
            RefreshRates();
            ticket=OrderSend(Symbol(),OP_BUY,pLots,Ask,sp,StopLong(Bid,sl),TakeLong(Ask,tp),pComment,pMagic,pExpiration,pColor);
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         } 
         break;
      case OP_SELLLIMIT:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_SELLLIMIT,pLots,pLevel,sp,StopShort(pr,sl),TakeShort(pLevel,tp),pComment,pMagic,pExpiration,pColor);
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         } 
         break;
      case OP_SELLSTOP:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_SELLSTOP,pLots,pLevel,sp,StopShort(pr,sl),TakeShort(pLevel,tp),pComment,pMagic,pExpiration,pColor);
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         } 
         break;
      case OP_SELL:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_SELL,pLots,Bid,sp,StopShort(Ask,sl),TakeShort(Bid,tp),pComment,pMagic,pExpiration,pColor);
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         } 
         break;
  } 
  
  return(ticket);
}  

double LotSize()
{ 
 int Leverage =  AccountLeverage(); 
 double AccMargin = AccountMargin();
 double lotMM;

 lotMM = NormalizeDouble((AccountFreeMargin()*RiskPercent/100)/(Leverage),1);
   
   if (lotMM < 0.1) lotMM = Lots;
   if  (lotMM > 100) lotMM = 100;
   return (lotMM);
} 


